import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)  
  
/** 
 * Write a description of class Player here. 
 *  
 * @author (your name)  
 * @version (a version number or a date) 
 */  
public class Player extends Actor  
{  
    public boolean moveRight = true;  
    public boolean moveLeft = true;  
    public boolean jumping = false;  
    public int jumpTime = 0;  
    protected double exactX;  
    protected double exactY;  
    public boolean facingRight = true;  
    public boolean facingLeft = false;  
    public int waitTillJump = 20;
    public boolean waitJumping = false;
  
    public Player()  
    {  
        getImage().scale(getImage().getWidth() + 3, getImage().getHeight() + 8);  
    }  
  
    public void act()  
    {  
        if(!onGround())  
        {  
            if (!jumping)  
            {  
                setLocation(getX(), getY() + 10);  
            }  
        }  
  
        if(jumping)  
        {  
            if(jumpTime < 6)  
            {  
                jumpTime++;  
                setLocation(getX(), getY() - 17);  
            }  
            else  
            {  
                jumpTime = 0;  
                jumping = false;  
            } 
        }  
        
        if (waitJumping)
        {
            if (waitTillJump >= 20)
            {
                waitTillJump = 0;
                jumping = true;
            }
        }
  
        if(onGround())  
        {  
            if (waitTillJump < 20)
            {
                waitTillJump++;
            }
            waitJumping = Greenfoot.isKeyDown("space");
        }  
  
        moveRight = !objectToRight();  
  
        moveLeft = !objectToLeft();  
  
        if(moveRight && (Greenfoot.isKeyDown("d") || Greenfoot.isKeyDown("right")))  
        {  
            setLocation(getX() + 5, getY());  
            if(facingRight == false)  
            {  
                getImage().mirrorHorizontally();  
                facingRight = true;  
                facingLeft = false;  
            }  
        }  
  
        if(moveLeft && (Greenfoot.isKeyDown("a") || Greenfoot.isKeyDown("left")))  
        {  
            setLocation(getX() - 5, getY());  
            if(facingLeft == false)  
            {  
                getImage().mirrorHorizontally();  
                facingRight = false;  
                facingLeft = true;  
            }  
        }  
    }  
  
    public void setLocation(double x, double y)   
    {    
        this.exactX = x;    
        this.exactY = y;    
        super.setLocation((int) x, (int) y);    
    }    
  
    public double getExactX()   
    {    
        return exactX;    
    }    
  
    public double getExactY()   
    {    
        return exactY;    
    }  
  
    public boolean onGround()  
    {  
        return getOneObjectAtOffset(0,getImage().getHeight() / 2, Block.class) != null;  
    }  
  
    public boolean ObjectAbove()  
    {  
        return getOneObjectAtOffset(0, getImage().getHeight() + 3, Block.class) != null;  
    }  
  
    public boolean objectToLeft()  
    {  
        return getOneObjectAtOffset(-1, 4, Block.class) != null;  
    }  
  
    public boolean objectToRight()  
    {  
        return getOneObjectAtOffset(-1,4, Block.class) != null;  
    }  
}  
