import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)  
  
/** 
 * Write a description of class Selector here. 
 *  
 * @author (your name)  
 * @version (a version number or a date) 
 */  
public class Selector extends Actor  
{  
    private MouseInfo mouse;  
    private PlayerWorld world;  
      
    public Selector()  
    {  
        getImage().scale(10,10);  
    }  
      
    /** 
     * Act - do whatever the Selector wants to do. This method is called whenever 
     * the 'Act' or 'Run' button gets pressed in the environment. 
     */  
    public void act()   
    {  
        mouse = Greenfoot.getMouseInfo();  
        if (world == null)  
            world = (PlayerWorld) getWorld();  
        if (mouse != null)  
        {  
           this.setLocation(mouse.getX(), mouse.getY());  
           if(Greenfoot.mouseClicked(null))  
            {  
                if(mouse.getButton() == 1)  
                {  
                    if(getObjectsInRange(100, Player.class).isEmpty() == false)  
                    {  
                        if(this.getIntersectingObjects(Block.class) != null)  
                        {  
                           getWorld().removeObject(this.getOneIntersectingObject(Block.class));  
                        }  
                    }  
                }  
                if(mouse.getButton() == 3)  
                {  
                    if(getObjectsInRange(100, Player.class).isEmpty() == false)  
                    {  
                        world.placeBlock(new Dirt(), getX(), getY());  
                    }  
                }  
            }  
        }  
    }      
      
    public void goTo(int x, int y)  
    {  
        this.setLocation(x, y);  
    }  
}  
